from soundfield.models import Sound, Comment
from django.http import HttpResponse
from django.core import serializers
from django.shortcuts import get_object_or_404
import logging
from django.views.decorators.csrf import csrf_exempt
import datetime
from django.conf import settings
import pdb

logger = logging.getLogger(__name__)

def sounds(request):
    sounds = Sound.objects.all().order_by('-pub_date')
    json_serializer = serializers.get_serializer("json")()
    output = json_serializer.serialize(sounds, ensure_ascii=False)
    return HttpResponse(output, content_type="application/json")

def sound_z(request):
    if request.GET:
      zacc=float(request.GET.get("zacc",'0'))
    else:
      zacc=-0.5
    closez = Sound.objects.filter(zacc__lt=zacc+0.1).filter(zacc__gt=zacc-0.1)[:3]

   # minz=100;
   # # linear search is generally no good
   # for s in sound:
   #   if abs(s.zacc-zacc)<minz:
   #     minz=abs(s.zacc-zacc)
   #     mins=s

    json_serializer = serializers.get_serializer("json")()
    output = json_serializer.serialize(closez, ensure_ascii=False)
    return HttpResponse(output, content_type="application/json")

@csrf_exempt
def sound(request,sound_id=0):
  # logging.debug(request.POST)
  # logging.debug("NAME: %s", request.POST["name"])
  try:
    if request.POST:
      sound = Sound(name=request.POST["name"], 
        #description=request.POST["description"],
        udid=request.POST["udid"],
        lat=request.POST["lat"],
        long=request.POST["long"],
        heading=request.POST["heading"],
        zacc=request.POST["zacc"],
        pub_date=datetime.date.today(),
        pub_time=datetime.datetime.now().time())
        #likes=0)

      file = request.FILES['soundfile']
      sound.path = str(datetime.datetime.now().microsecond) #total hack
      destination = open(settings.MEDIA_ROOT + sound.path, 'wb+')
      for chunk in file.chunks():
          destination.write(chunk)
      destination.close()
      sound.save()
      logging.debug("this is the sound id: %d", sound.id)
      sound_id = sound.id
  except Exception, e:
      print e
      logging.debug(e)
  else:
      sound = Sound.objects.all()
      #if request.GET:
        #TODO
        #filts=request.GET
      json_serializer = serializers.get_serializer("json")()
      output = json_serializer.serialize(sound, ensure_ascii=False)
      return HttpResponse(output, content_type="application/json")
