from django.db import models

class Media(models.Model):
    #name = models.CharField(max_length=100)
    #path = models.FilePathField()
    uuid = models.CharField(max_length=100)
    tour_stop = models.IntegerField(null=True)
    stop_primary = models.BooleanField(default=False)
    media_type = models.IntegerField() # 0 is audio, 1 is image
    pub_date = models.DateField()#'date published')
    pub_time = models.TimeField()
    lat = models.FloatField()
    long = models.FloatField()
    heading = models.FloatField()
    yacc = models.FloatField()
    xacc = models.FloatField()
    zacc = models.FloatField()


class Audio(models.Model):
  uuid = models.CharField(max_length=100)
  #features

class Image(models.Model):
  uuid = models.CharField(max_length=100)
  #features

class MediaPair(models.Model):
  audio = models.ForeignKey('Audio')
  image = models.ForeignKey('Image')
  audio_uuid =  models.CharField(max_length=100)
  image_uuid = models.CharField(max_length=100)
  pub_date = models.DateField()#'date published')
  pub_time = models.TimeField()
  lat = models.FloatField()
  long = models.FloatField()
  heading = models.FloatField()
  yacc = models.FloatField()
  xacc = models.FloatField()
  zacc = models.FloatField() 

class Color(models.Model):
  name = models.CharField(max_length=30) # for some 128 color crayola shit

class ImageHistBlock(models.Model):
  """ stores blocks of a color histogram of an image. each row stores one value 
  for one color (RGB) for one grid position for one image. """
  image = models.ForeignKey('Image')
  red = models.FloatField()
  green = models.FloatField()
  blue = models.FloatField()
  grid_row = models.IntegerField()
  grid_col = models.IntegerField()
  num_rows = models.IntegerField()#img divided into this many rows
  num_cols = models.IntegerField()#img divided into this many cols
  #color = models.ForeignKey('Color')
  #value = models.FloatField()

class AudioFeats(models.Model):
  """ stores rms and mean and var of 13 mfccs"""
  audio = models.ForeignKey('Audio')
  rms=models.FloatField()
  win_size=models.IntegerField()

  mfcc1_mean=models.FloatField()
  mfcc2_mean=models.FloatField()
  mfcc3_mean=models.FloatField()
  mfcc4_mean=models.FloatField()
  mfcc5_mean=models.FloatField()
  mfcc6_mean=models.FloatField()
  mfcc7_mean=models.FloatField()
  mfcc8_mean=models.FloatField()
  mfcc9_mean=models.FloatField()
  mfcc10_mean=models.FloatField()
  mfcc11_mean=models.FloatField()
  mfcc12_mean=models.FloatField()
  mfcc13_mean=models.FloatField()

  mfcc1_var=models.FloatField()
  mfcc2_var=models.FloatField()
  mfcc3_var=models.FloatField()
  mfcc4_var=models.FloatField()
  mfcc5_var=models.FloatField()
  mfcc6_var=models.FloatField()
  mfcc7_var=models.FloatField()
  mfcc8_var=models.FloatField()
  mfcc9_var=models.FloatField()
  mfcc10_var=models.FloatField()
  mfcc11_var=models.FloatField()
  mfcc12_var=models.FloatField()
  mfcc13_var=models.FloatField()
