import os
os.environ['HOME']='/Users/dt/code/static/tmp'

from tour.models import *
from django.http import HttpResponse
from django.core import serializers
from extract_img_feats import *
from extract_audio_feats import *
from django.shortcuts import get_object_or_404
import logging
from django.views.decorators.csrf import csrf_exempt
import datetime
from django.conf import settings
from random import random

logger = logging.getLogger(__name__)

def sounds(request):
    sounds = Sound.objects.all().order_by('-pub_date')
    json_serializer = serializers.get_serializer("json")()
    output = json_serializer.serialize(sounds, ensure_ascii=False)
    return HttpResponse(output, content_type="application/json")

@csrf_exempt
def media(request):
  # logging.debug(request.POST)
  # logging.debug("NAME: %s", request.POST["name"])
  try:
    if request.POST:
      post_params=dict(request.POST.items())
      media = Media(
        pub_date=datetime.date.today(),
        pub_time=datetime.datetime.now().time(),
        **post_params)
      #media = Media(
        #tour_stop=requset.POST["tour_stop"],
        #lat=request.POST["lat"],
        #long=request.POST["long"],
        #heading=request.POST["heading"],
        #xacc=request.POST["xacc"],
        #yacc=request.POST["yacc"],
        #zacc=request.POST["zacc"],
        #likes=0)
      file = request.FILES['mediafile']
      media.path = media.uuid
      destination = open(settings.MEDIA_ROOT + media.path, 'wb+')
      for chunk in file.chunks():
          destination.write(chunk)
      destination.close()
      media.save()

      #logging.debug("this is the sound id: %d", sound.id)
      #media_id = media.id
    medias=Media.objects.all()[:2]
    if request.GET:
      get_params=dict(request.GET.items())
      medias= filter_results(get_params)
  except Exception, e:
    print "error: " + e
    #logging.debug(e)

  json_serializer = serializers.get_serializer("json")()
  output = json_serializer.serialize(medias, ensure_ascii=False)
  return HttpResponse(output, content_type="application/json")

@csrf_exempt
def mediapair(request,randy=False):
  # logging.debug(request.POST)
  # logging.debug("NAME: %s", request.POST["name"])
  if request.POST:
    try:
      post_params=dict(request.POST.items())
      # no longer popping b/c i actually wanna store both uuids in the table
      # TODO this setup doesn't really make sense...
      #audi = Audio(uuid=post_params.pop('audio_uuid'));
      audi = Audio(uuid=post_params['audio_uuid']);
      audi.save()
      #img= Image(uuid=post_params.pop('img_uuid'));
      img= Image(uuid=post_params['image_uuid']);
      img.save()

      media = MediaPair(
        audio=audi,
        image=img,
        pub_date=datetime.date.today(),
        pub_time=datetime.datetime.now().time(),
        **post_params)
      #media = Media(
        #tour_stop=requset.POST["tour_stop"],
        #lat=request.POST["lat"],
        #long=request.POST["long"],
        #heading=request.POST["heading"],
        #xacc=request.POST["xacc"],
        #yacc=request.POST["yacc"],
        #zacc=request.POST["zacc"],
        #likes=0)

      media.save()
      
      #write audio file
      audio_file = request.FILES['audio_file']
      destination = open(settings.MEDIA_ROOT + audi.uuid, 'wb+')
      for chunk in audio_file.chunks():
          destination.write(chunk)
      destination.close()

      #write image file
      img_file = request.FILES['img_file']
      destination = open(settings.MEDIA_ROOT + img.uuid, 'wb+')
      for chunk in img_file.chunks():
          destination.write(chunk)
      destination.close()

      extract_audio_feats(audi.uuid,True)
      extract_hist(img.uuid,True)
      extract_hist(img.uuid,True,num_cols=1,num_rows=1)

    except Exception, e:
      print "Error:"
      print e
      
    return HttpResponse('[]', content_type="application/json")

  elif request.GET:
    if randy:
      medias=MediaPair.objects.all().order_by('?')[:15]
    else:
      medias=MediaPair.objects.all()[:2]
    #get_params=dict(request.GET.items())
    #medias= filter_results(get_params)
  else:
    medias=MediaPair.objects.all()[:2]
    #logging.debug(e)

  json_serializer = serializers.get_serializer("json")()
  output = json_serializer.serialize(medias, ensure_ascii=False)
  return HttpResponse(output, content_type="application/json")

@csrf_exempt
def audio_search(request):
  if request.POST:
    # shouldn't be here
    try:
      post_params=dict(request.POST.items())
      # no longer popping b/c i actually wanna store both uuids in the table
      # TODO this setup doesn't really make sense...
      #audi = Audio(uuid=post_params.pop('audio_uuid'));
      audi = Audio(uuid=post_params['audio_uuid']);
      audi.save()
      #img= Image(uuid=post_params.pop('img_uuid'));
      img= Image(uuid=post_params['image_uuid']);
      img.save()

      media = MediaPair(
        audio=audi,
        image=img,
        pub_date=datetime.date.today(),
        pub_time=datetime.datetime.now().time(),
        **post_params)
      #media = Media(
        #tour_stop=requset.POST["tour_stop"],
        #lat=request.POST["lat"],
        #long=request.POST["long"],
        #heading=request.POST["heading"],
        #xacc=request.POST["xacc"],
        #yacc=request.POST["yacc"],
        #zacc=request.POST["zacc"],
        #likes=0)

      media.save()
      
      #write audio file
      audio_file = request.FILES['audio_file']
      destination = open(settings.MEDIA_ROOT + audi.uuid, 'wb+')
      for chunk in audio_file.chunks():
          destination.write(chunk)
      destination.close()

      #write image file
      img_file = request.FILES['img_file']
      destination = open(settings.MEDIA_ROOT + img.uuid, 'wb+')
      for chunk in img_file.chunks():
          destination.write(chunk)
      destination.close()

      extract_audio_feats(audi.uuid,True)
      extract_hist(img.uuid,True)

    except Exception, e:
      print "Error:"
      print e
      
    return HttpResponse('[]', content_type="application/json")

  elif request.GET:
    auuid=request.GET['audio_uuid']
    medias=find_closest_audio(auuid) 
    #get_params=dict(request.GET.items())
    #medias= filter_results(get_params)
  else:
    medias=MediaPair.objects.all().order_by('?')[:10]
    #logging.debug(e)

  json_serializer = serializers.get_serializer("json")()
  output = json_serializer.serialize(medias, ensure_ascii=False)
  return HttpResponse(output, content_type="application/json")


@csrf_exempt
def image_search(request):
  if request.POST:
    # shouldn't be here
    try:
      post_params=dict(request.POST.items())
      # no longer popping b/c i actually wanna store both uuids in the table
      # TODO this setup doesn't really make sense...
      #audi = Audio(uuid=post_params.pop('audio_uuid'));
      audi = Audio(uuid=post_params['audio_uuid']);
      audi.save()
      #img= Image(uuid=post_params.pop('img_uuid'));
      img= Image(uuid=post_params['image_uuid']);
      img.save()

      media = MediaPair(
        audio=audi,
        image=img,
        pub_date=datetime.date.today(),
        pub_time=datetime.datetime.now().time(),
        **post_params)
      #media = Media(
        #tour_stop=requset.POST["tour_stop"],
        #lat=request.POST["lat"],
        #long=request.POST["long"],
        #heading=request.POST["heading"],
        #xacc=request.POST["xacc"],
        #yacc=request.POST["yacc"],
        #zacc=request.POST["zacc"],
        #likes=0)

      media.save()
      
      #write audio file
      audio_file = request.FILES['audio_file']
      destination = open(settings.MEDIA_ROOT + audi.uuid, 'wb+')
      for chunk in audio_file.chunks():
          destination.write(chunk)
      destination.close()

      #write image file
      img_file = request.FILES['img_file']
      destination = open(settings.MEDIA_ROOT + img.uuid, 'wb+')
      for chunk in img_file.chunks():
          destination.write(chunk)
      destination.close()

      extract_audio_feats(audi.uuid,True)
      extract_hist(img.uuid,True)

    except Exception, e:
      print "Error:"
      print e
      
    return HttpResponse('[]', content_type="application/json")

  elif request.GET:
    iuuid=request.GET['image_uuid']
    medias=find_closest_hist3(iuuid)
    #get_params=dict(request.GET.items())
    #medias= filter_results(get_params)
  else:
    medias=MediaPair.objects.all().order_by('?')[:10]
    #logging.debug(e)

  json_serializer = serializers.get_serializer("json")()
  output = json_serializer.serialize(medias, ensure_ascii=False)
  return HttpResponse(output, content_type="application/json")


def filter_results(qdict):
  """ filter results scans through each Media object and assigns it a score
      based on how close it is to the values in they query. probs supaslow"""
  meds=Media.objects.filter(media_type=qdict['media_type']).filter(tour_stop=qdict['tour_stop']).order_by('?')
  if qdict.has_key('stop_primary'):
    meds=meds.filter(stop_primary=qdict['stop_primary'])

  return meds[:20]

  # order by heading
  #rankings=[]
#  for m in meds:
#    heading = float(qdict.get("heading",random()*360))
#    r = abs((360+m.heading) - (360+heading))/90
#    rankings.append((r,m))
#  srtd_rankings=sorted(rankings)
#
#  return [y for (x,y) in srtd_rankings[:20]]
